package freechartservlet;

import java.awt.image.RenderedImage;
import java.io.IOException;
import javax.imageio.ImageIO;
import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jfree.chart.ChartFactory;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.data.category.DefaultCategoryDataset;
import org.jfree.ui.RectangleEdge;

public class grafico extends HttpServlet {

    DefaultCategoryDataset dataset = new DefaultCategoryDataset();

    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code>
     * methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("image/png");
        try (ServletOutputStream os = response.getOutputStream()) {

            try {
                String luogo = request.getParameter("luogo");
                double lun = Double.parseDouble(request.getParameter("lun"));
                double mar = Double.parseDouble(request.getParameter("mar"));
                double mer = Double.parseDouble(request.getParameter("mer"));
                double gio = Double.parseDouble(request.getParameter("gio"));
                double ven = Double.parseDouble(request.getParameter("ven"));
                double sab = Double.parseDouble(request.getParameter("sab"));
                double dom = Double.parseDouble(request.getParameter("dom"));

                dataset.addValue(lun, luogo, "Lunedì");
                dataset.addValue(mar, luogo, "Martedì");
                dataset.addValue(mer, luogo, "Mercoledì");
                dataset.addValue(gio, luogo, "Giovedì");
                dataset.addValue(ven, luogo, "Venerdì");
                dataset.addValue(sab, luogo, "Sabato");
                dataset.addValue(dom, luogo, "Domenica");
            } catch (NumberFormatException e) {
            }

            JFreeChart chart = ChartFactory.createLineChart("Temperature settimanali",
                    "Giorni della settimana", "t (°C)",
                    dataset, PlotOrientation.VERTICAL, true, true, false);
            chart.getLegend().setPosition(RectangleEdge.RIGHT);

            RenderedImage chartImage = chart.createBufferedImage(700, 300);
            ImageIO.write(chartImage, "png", os);
            os.flush();
            os.close();
        }
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
